# Developer Guidelines

## First Steps

1. Read the API high-level/overview information at:
   - [`libgraphtheory`](libgraphtheory)
   - [`stc`](src)
2. Compile:
   - have a look at the `CMake` output!
3. Run Tests and Run Application:
   - `make tests`

## API Documentation

The Rocs API is reasonable good documentation in most parts of Rocs,
especially in the RocsCore library. You can either
[create the doxygen files by hand](http://techbase.kde.org/Development/Tools/apidox)
or use the nightly updated references at https://api.kde.org.

## Project ToDo List

Please read/update the
[Community Wiki Page](http://community.kde.org/KDEEdu/Rocs/Todo).

## Coding Styles

The coding styles are (slowly) converging to the
[KDE-libs coding styles](http://techbase.kde.org/Policies/Kdelibs_Coding_Style).

## Mailing Lists

Rocs is part of KDE Edu, which has the 
[kde-edu@kde.org](mailto:kde-edu@kde.org) mailing list.

For technical discussion, which are only within the scope of the Rocs project,
we have the [rocs-devel@kde.org](mailto:rocs-devel@kde.org) mailing list.
